<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import Vue from 'vue';
import {
  CityHero,
  ConductBanner,
  Agenda,
  WorldTourFormMulti,
  WorldTourForm,
  Sponsor,
} from '~/components/events/world-tour/index.vue';
import { NextStep } from '~/components/common/index.vue';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import {
  worldTourEventsDataHelper,
  WorldTourEventsData,
} from '~/services/events/world-tour.events.service';

export default Vue.extend({
  components: {
    CityHero,
    ConductBanner,
    NextStep,
    Agenda,
    WorldTourFormMulti,
    Sponsor,
    WorldTourForm,
  },
  nuxtI18n: false,
  async asyncData({ params }: any) {
    const eventSlug = params.city;
    const city: WorldTourEventsData = await getClient()
      .getEntries({
        content_type: CONTENT_TYPES.EVENT,
        include: 10,
        'fields.slug': eventSlug,
      })
      .then((query: any) => {
        const entryFields = query.items[0]?.fields;
        return worldTourEventsDataHelper(entryFields);
      })
      .catch(console.error);
    return { city };
  },
  head(): MetaInfo {
    return {
      ...getPageMetadata((this as any).city.metadata, this.$route.path),
    };
  },
});
</script>

<template>
  <div>
    <CityHero
      v-if="city.hero"
      v-bind="city.hero"
      :registration-closed="city.form.registrationClosed"
      :location="city.location"
      :date="city.date"
    />
    <Agenda
      v-if="city.agenda"
      v-bind="city.agenda"
      :registration-closed="city.form.registrationClosed"
      :location="city.location"
    />
    <WorldTourFormMulti
      v-if="city.form && city.form.multiStepForm"
      v-bind="city.form"
    />

    <WorldTourForm
      v-if="city.form && !city.form.multiStepForm"
      v-bind="city.form"
    />

    <Sponsor v-if="city.sponsors" v-bind="city.sponsors[0]" />

    <div v-if="city.footnote">
      <ConductBanner
        v-for="footnote in city.footnote"
        :key="footnote.header"
        v-bind="footnote"
        class="city__section"
      />
    </div>

    <SlpContainer v-if="city.nextSteps" variant="gradient">
      <NextStep :variant="city.nextSteps" />
    </SlpContainer>
  </div>
</template>
<style lang="scss" scoped>
.city {
  &__section {
    & + .city__section {
      padding-top: 0;
    }
  }
}
</style>
